NX Open C++ Reference Guide
|
Studio Spline builder class. More...
Public Member Functions | |
bool | CanUseOrientationTool () |
Returns the flag indicating if WCS like tool should be deployed when a point or pole handle is selected Created in NX8.5.1. | |
NXOpen::Features::GeometricConstraintDataManager * | ConstraintManager () |
Returns the constraint manager Created in NX8.0.0. | |
NXOpen::CoordinateSystem * | ConstraintPlane () |
Returns the coordinate system defining plane constraint Created in NX8.0.0. | |
NXOpen::Spline * | Curve () |
Returns the spline curve Created in NX8.0.0. | |
int | Degree () |
Returns the degree Created in NX8.0.0. | |
NXOpen::Plane * | DrawingPlane () |
Returns the drawing plane Created in NX8.0.0. | |
NXOpen::Features::StudioSplineBuilderEx::DrawingPlaneOptions | DrawingPlaneOption () |
Returns a drawing plane option Created in NX8.0.0. | |
void | EditSpline (NXOpen::NXObject *spline) |
Sets a non-parametric spline for editing Created in NX8.0.0. | |
void | Evaluate () |
Evaluates the spline Created in NX8.0.0. | |
NXOpen::GeometricUtilities::SplineExtensionBuilder * | Extender () |
Returns the extension option Created in NX8.0.0. | |
std::vector< double > | GetKnots () |
Queries the knot sequence for by pole spline. | |
std::vector< double > | GetParameters () |
Queries the parameters at defining points for a through point spline. | |
bool | HasPlaneConstraint () |
Returns the flag indicating if spline has plane constraint Created in NX8.0.0. | |
bool | HasProportionalUpdate () |
Returns the flag indicating if free or non attached defining points or poles should be moved proportionally during update of the spline feature Created in NX8.0.0. | |
NXOpen::Features::StudioSplineBuilderEx::InputCurveOptions | InputCurveOption () |
Returns the input curve option Created in NX8.0.0. | |
void | InsertKnot (const NXOpen::Point3d &point) |
Inserts knot at a closest point on the spline Created in NX8.0.0. | |
void | InsertPole (int afterIndex) |
Inserts a pole in the middle of a control polygon segment Created in NX8.0.0. | |
bool | IsAssociative () |
Returns the flag indicating if a feature should be created Created in NX8.0.0. | |
bool | IsPeriodic () |
Returns the periodicity Created in NX8.0.0. | |
bool | IsSingleSegment () |
Returns a flag indicating if single segment by pole spline is to be created Created in NX8.0.0. | |
NXOpen::Features::StudioSplineBuilderEx::MatchKnotsTypes | MatchKnotsType () |
Returns a constraint to match knots at the defining points for a through point spline Created in NX8.0.0. | |
NXOpen::Features::StudioSplineBuilderEx::MovementMethodType | MovementMethod () |
Returns the movement method Created in NX8.0.0. | |
NXOpen::Plane * | MovementPlane () |
Returns the movement plane Created in NX8.0.0. | |
NXOpen::Direction * | MovementVector () |
Returns the movement vector Created in NX8.0.0. | |
NXOpen::GeometricUtilities::OrientXpressBuilder * | OrientExpress () |
Returns the orient express object Created in NX8.0.0. | |
void | SetAssociative (bool associative) |
Sets the flag indicating if a feature should be created Created in NX8.0.0. | |
void | SetCanUseOrientationTool (bool useOrientationTool) |
Sets the flag indicating if WCS like tool should be deployed when a point or pole handle is selected Created in NX8.5.1. | |
void | SetConstraintPlane (NXOpen::CoordinateSystem *coordinateSystem) |
Sets the coordinate system defining plane constraint Created in NX8.0.0. | |
void | SetDegree (int degree) |
Sets the degree Created in NX8.0.0. | |
void | SetDrawingPlane (NXOpen::Plane *drawingPlane) |
Sets the drawing plane Created in NX8.0.0. | |
void | SetDrawingPlaneOption (NXOpen::Features::StudioSplineBuilderEx::DrawingPlaneOptions planeOption) |
Sets a drawing plane option Created in NX8.0.0. | |
void | SetHasPlaneConstraint (bool hasConstraint) |
Sets the flag indicating if spline has plane constraint Created in NX8.0.0. | |
void | SetHasProportionalUpdate (bool hasProportionalUpdate) |
Sets the flag indicating if free or non attached defining points or poles should be moved proportionally during update of the spline feature Created in NX8.0.0. | |
void | SetInputCurveOption (NXOpen::Features::StudioSplineBuilderEx::InputCurveOptions option) |
Sets the input curve option Created in NX8.0.0. | |
void | SetKnots (const std::vector< double > &knots) |
Sets the optional knot sequence for by pole spline Created in NX8.0.0. | |
void | SetMatchKnotsType (NXOpen::Features::StudioSplineBuilderEx::MatchKnotsTypes matchKnotsType) |
Sets a constraint to match knots at the defining points for a through point spline Created in NX8.0.0. | |
void | SetMovementMethod (NXOpen::Features::StudioSplineBuilderEx::MovementMethodType movementMethod) |
Sets the movement method Created in NX8.0.0. | |
void | SetMovementPlane (NXOpen::Plane *movementPlane) |
Sets the movement plane Created in NX8.0.0. | |
void | SetMovementVector (NXOpen::Direction *movementVector) |
Sets the movement vector Created in NX8.0.0. | |
void | SetParameters (const std::vector< double > ¶meters) |
Sets the optional parameters at defining points for a through point spline Created in NX8.0.0. | |
void | SetPeriodic (bool periodicity) |
Sets the periodicity Created in NX8.0.0. | |
void | SetSingleSegment (bool isSingleSegment) |
Sets a flag indicating if single segment by pole spline is to be created Created in NX8.0.0. | |
void | SetType (NXOpen::Features::StudioSplineBuilderEx::Types type) |
Sets the spline method Created in NX8.0.0. | |
void | SetWCSOption (NXOpen::Features::StudioSplineBuilderEx::WCSOptionType wcsOption) |
Sets the WCS option Created in NX8.0.0. | |
NXOpen::Features::StudioSplineBuilderEx::Types | Type () |
Returns the spline method Created in NX8.0.0. | |
void | UpdateOnConstraintPlane () |
Updates spline based on constraint plane Created in NX8.0.0. | |
NXOpen::Features::StudioSplineBuilderEx::WCSOptionType | WCSOption () |
Returns the WCS option Created in NX8.0.0. | |
![]() | |
NXOpen::Features::Feature * | CommitFeature () |
Commits the feature parameters and creates the feature. | |
NXOpen::Features::Feature * | GetFeature () |
Returns the feature currently being edited by this builder. | |
void | HideInternalParentFeatureAfterEdit (NXOpen::Features::Feature *parentFeature) |
Re-suppress an internal parent feature (a slave feature) after it has been edited. | |
bool | ParentFeatureInternal () |
Returns whether or not the latest timestamped parent feature of this feature should be made internal Created in NX5.0.0. | |
bool | PatchSolutionFlag () |
Returns the patch solution flag Created in NX8.0.1. | |
NXString | PatchSurfaceFilename () |
Returns the patch surface filename Created in NX8.0.1. | |
void | SetParentFeatureInternal (NXOpen::Features::Feature *parentFeature) |
Set the parent features which would be internal or slaves to the feature being created or commited Created in NX6.0.0. | |
void | SetParentFeatureInternal (bool isInternal) |
Sets whether or not the latest timestamped parent feature of this feature should be made internal Created in NX5.0.0. | |
void | SetPatchSolutionFlag (bool optionValue) |
Sets the patch solution flag Created in NX8.0.1. | |
void | SetPatchSurfaceFilename (const NXString &surfaceFilename) |
Sets the patch surface filename Created in NX8.0.1. | |
void | SetPatchSurfaceFilename (const char *surfaceFilename) |
Sets the patch surface filename Created in NX8.0.1. | |
void | SetSurroundingPatchSurfaceFilename (const NXString &surroundingSurfaceFilename) |
Sets the surrounding patch surface filename Created in NX8.0.1. | |
void | SetSurroundingPatchSurfaceFilename (const char *surroundingSurfaceFilename) |
Sets the surrounding patch surface filename Created in NX8.0.1. | |
void | ShowInternalParentFeatureForEdit (NXOpen::Features::Feature *parentFeature) |
Unsuppress an internal parent feature (a slave feature) so it can be edited. | |
NXString | SurroundingPatchSurfaceFilename () |
Returns the surrounding patch surface filename Created in NX8.0.1. | |
void | UnsetParentFeatureInternal (NXOpen::Features::Feature *parentFeature) |
Set the internal parent feature of the feature being edited to external Created in NX6.0.0. | |
![]() | |
NXOpen::NXObject * | Commit () |
Commits any edits that have been applied to the builder. | |
void | Destroy () |
Deletes the builder, and cleans up any objects created by the builder. | |
std::vector< NXOpen::NXObject * > | GetCommittedObjects () |
For builders that create more than one object, this method returns the objects that are created by commit. | |
NXOpen::NXObject * | GetObject () |
Returns the object currently being edited by this builder. | |
void | ShowResults () |
Updates the model to reflect the result of an edit to the model for all builders that support showing results. | |
virtual bool | Validate () |
Validate whether the inputs to the component are sufficient for commit to be called. | |
![]() | |
tag_t | GetTag () const |
<b>Deprecated</b>:<br> Use Tag instead. | |
tag_t | Tag () const |
Returns the tag of this object. | |
Studio Spline builder class.
To create a new instance of this class, use Features::FeatureCollection::CreateStudioSplineBuilderEx
Default values.
Property | Value |
---|---|
DrawingPlaneOption | |
Extender.EndExtensionOption |
None |
Extender.EndValue.Value |
0 (millimeters part), 0 (inches part) |
Extender.StartExtensionOption |
None |
Extender.StartValue.Value |
0 (millimeters part), 0 (inches part) |
InputCurveOption |
Hide |
MatchKnotsType |
None |
MovementMethod | |
Type |
ThroughPoints |
WCSOption |
X |
Created in NX8.0.0.
Drawing plane options.
DrawingPlaneOptionsView |
View plane. |
DrawingPlaneOptionsXY |
XY plane. |
DrawingPlaneOptionsYZ |
YZ plane. |
DrawingPlaneOptionsXZ |
XZ plane. |
DrawingPlaneOptionsGeneral |
General plane. |
Options of the actions to be taken on an input non-parametric spline after its editing is done.
These options are used only while trying to make non-parametric spline a feature.
Options for creating knots at the defining points in case of through point spline.
Points movement types.
MovementMethodTypeWCS |
Movement along WCS principal axis or plane. |
MovementMethodTypeView |
Movement in view plane. |
MovementMethodTypeVector |
Movement along arbitrary direction. |
MovementMethodTypePlane |
Movement in arbitrary plane. |
MovementMethodTypeNormal |
Movement along a face normal. |
MovementMethodTypePolygon |
Movement along a relevant control polygon segment. |
WCS principal axis or plane types.
bool NXOpen::Features::StudioSplineBuilderEx::CanUseOrientationTool | ( | ) |
Returns the flag indicating if WCS like tool should be deployed when a point or pole handle is selected
Created in NX8.5.1.
License requirements : None
NXOpen::Features::GeometricConstraintDataManager* NXOpen::Features::StudioSplineBuilderEx::ConstraintManager | ( | ) |
Returns the constraint manager
Created in NX8.0.0.
License requirements : None
NXOpen::CoordinateSystem* NXOpen::Features::StudioSplineBuilderEx::ConstraintPlane | ( | ) |
Returns the coordinate system defining plane constraint
Created in NX8.0.0.
License requirements : None
NXOpen::Spline* NXOpen::Features::StudioSplineBuilderEx::Curve | ( | ) |
Returns the spline curve
Created in NX8.0.0.
License requirements : None
int NXOpen::Features::StudioSplineBuilderEx::Degree | ( | ) |
Returns the degree
Created in NX8.0.0.
License requirements : None
NXOpen::Plane* NXOpen::Features::StudioSplineBuilderEx::DrawingPlane | ( | ) |
Returns the drawing plane
Created in NX8.0.0.
License requirements : None
NXOpen::Features::StudioSplineBuilderEx::DrawingPlaneOptions NXOpen::Features::StudioSplineBuilderEx::DrawingPlaneOption | ( | ) |
Returns a drawing plane option
Created in NX8.0.0.
License requirements : None
void NXOpen::Features::StudioSplineBuilderEx::EditSpline | ( | NXOpen::NXObject * | spline | ) |
Sets a non-parametric spline for editing
Created in NX8.0.0.
License requirements : features_modeling ("FEATURES MODELING") OR cam_base ("CAM BASE")
spline | spline |
void NXOpen::Features::StudioSplineBuilderEx::Evaluate | ( | ) |
Evaluates the spline
Created in NX8.0.0.
License requirements : features_modeling ("FEATURES MODELING") OR cam_base ("CAM BASE")
NXOpen::GeometricUtilities::SplineExtensionBuilder* NXOpen::Features::StudioSplineBuilderEx::Extender | ( | ) |
Returns the extension option
Created in NX8.0.0.
License requirements : None
std::vector<double> NXOpen::Features::StudioSplineBuilderEx::GetKnots | ( | ) |
Queries the knot sequence for by pole spline.
std::vector<double> NXOpen::Features::StudioSplineBuilderEx::GetParameters | ( | ) |
Queries the parameters at defining points for a through point spline.
bool NXOpen::Features::StudioSplineBuilderEx::HasPlaneConstraint | ( | ) |
Returns the flag indicating if spline has plane constraint
Created in NX8.0.0.
License requirements : None
bool NXOpen::Features::StudioSplineBuilderEx::HasProportionalUpdate | ( | ) |
Returns the flag indicating if free or non attached defining points or poles should be moved proportionally during update of the spline feature
Created in NX8.0.0.
License requirements : None
NXOpen::Features::StudioSplineBuilderEx::InputCurveOptions NXOpen::Features::StudioSplineBuilderEx::InputCurveOption | ( | ) |
Returns the input curve option
Created in NX8.0.0.
License requirements : None
void NXOpen::Features::StudioSplineBuilderEx::InsertKnot | ( | const NXOpen::Point3d & | point | ) |
Inserts knot at a closest point on the spline
Created in NX8.0.0.
License requirements : features_modeling ("FEATURES MODELING") OR cam_base ("CAM BASE")
point | Point at which knot to be inserted |
void NXOpen::Features::StudioSplineBuilderEx::InsertPole | ( | int | afterIndex | ) |
Inserts a pole in the middle of a control polygon segment
Created in NX8.0.0.
License requirements : features_modeling ("FEATURES MODELING") OR cam_base ("CAM BASE")
afterIndex | Index of a pole after which to insert new pole |
bool NXOpen::Features::StudioSplineBuilderEx::IsAssociative | ( | ) |
Returns the flag indicating if a feature should be created
Created in NX8.0.0.
License requirements : None
bool NXOpen::Features::StudioSplineBuilderEx::IsPeriodic | ( | ) |
Returns the periodicity
Created in NX8.0.0.
License requirements : None
bool NXOpen::Features::StudioSplineBuilderEx::IsSingleSegment | ( | ) |
Returns a flag indicating if single segment by pole spline is to be created
Created in NX8.0.0.
License requirements : None
NXOpen::Features::StudioSplineBuilderEx::MatchKnotsTypes NXOpen::Features::StudioSplineBuilderEx::MatchKnotsType | ( | ) |
Returns a constraint to match knots at the defining points for a through point spline
Created in NX8.0.0.
License requirements : None
NXOpen::Features::StudioSplineBuilderEx::MovementMethodType NXOpen::Features::StudioSplineBuilderEx::MovementMethod | ( | ) |
Returns the movement method
Created in NX8.0.0.
License requirements : None
NXOpen::Plane* NXOpen::Features::StudioSplineBuilderEx::MovementPlane | ( | ) |
Returns the movement plane
Created in NX8.0.0.
License requirements : None
NXOpen::Direction* NXOpen::Features::StudioSplineBuilderEx::MovementVector | ( | ) |
Returns the movement vector
Created in NX8.0.0.
License requirements : None
NXOpen::GeometricUtilities::OrientXpressBuilder* NXOpen::Features::StudioSplineBuilderEx::OrientExpress | ( | ) |
Returns the orient express object
Created in NX8.0.0.
License requirements : None
void NXOpen::Features::StudioSplineBuilderEx::SetAssociative | ( | bool | associative | ) |
Sets the flag indicating if a feature should be created
Created in NX8.0.0.
License requirements : features_modeling ("FEATURES MODELING") OR cam_base ("CAM BASE")
associative | associative |
void NXOpen::Features::StudioSplineBuilderEx::SetCanUseOrientationTool | ( | bool | useOrientationTool | ) |
Sets the flag indicating if WCS like tool should be deployed when a point or pole handle is selected
Created in NX8.5.1.
License requirements : features_modeling ("FEATURES MODELING") OR cam_base ("CAM BASE")
useOrientationTool | useorientationtool |
void NXOpen::Features::StudioSplineBuilderEx::SetConstraintPlane | ( | NXOpen::CoordinateSystem * | coordinateSystem | ) |
Sets the coordinate system defining plane constraint
Created in NX8.0.0.
License requirements : features_modeling ("FEATURES MODELING") OR cam_base ("CAM BASE")
coordinateSystem | coordinatesystem |
void NXOpen::Features::StudioSplineBuilderEx::SetDegree | ( | int | degree | ) |
Sets the degree
Created in NX8.0.0.
License requirements : features_modeling ("FEATURES MODELING") OR cam_base ("CAM BASE")
degree | degree |
void NXOpen::Features::StudioSplineBuilderEx::SetDrawingPlane | ( | NXOpen::Plane * | drawingPlane | ) |
Sets the drawing plane
Created in NX8.0.0.
License requirements : features_modeling ("FEATURES MODELING") OR cam_base ("CAM BASE")
drawingPlane | drawingplane |
void NXOpen::Features::StudioSplineBuilderEx::SetDrawingPlaneOption | ( | NXOpen::Features::StudioSplineBuilderEx::DrawingPlaneOptions | planeOption | ) |
Sets a drawing plane option
Created in NX8.0.0.
License requirements : features_modeling ("FEATURES MODELING") OR cam_base ("CAM BASE")
planeOption | planeoption |
void NXOpen::Features::StudioSplineBuilderEx::SetHasPlaneConstraint | ( | bool | hasConstraint | ) |
Sets the flag indicating if spline has plane constraint
Created in NX8.0.0.
License requirements : features_modeling ("FEATURES MODELING") OR cam_base ("CAM BASE")
hasConstraint | hasconstraint |
void NXOpen::Features::StudioSplineBuilderEx::SetHasProportionalUpdate | ( | bool | hasProportionalUpdate | ) |
Sets the flag indicating if free or non attached defining points or poles should be moved proportionally during update of the spline feature
Created in NX8.0.0.
License requirements : features_modeling ("FEATURES MODELING") OR cam_base ("CAM BASE")
hasProportionalUpdate | hasproportionalupdate |
void NXOpen::Features::StudioSplineBuilderEx::SetInputCurveOption | ( | NXOpen::Features::StudioSplineBuilderEx::InputCurveOptions | option | ) |
Sets the input curve option
Created in NX8.0.0.
License requirements : features_modeling ("FEATURES MODELING") OR cam_base ("CAM BASE")
option | option |
void NXOpen::Features::StudioSplineBuilderEx::SetKnots | ( | const std::vector< double > & | knots | ) |
Sets the optional knot sequence for by pole spline
Created in NX8.0.0.
License requirements : features_modeling ("FEATURES MODELING") OR cam_base ("CAM BASE")
knots | The knot sequence |
void NXOpen::Features::StudioSplineBuilderEx::SetMatchKnotsType | ( | NXOpen::Features::StudioSplineBuilderEx::MatchKnotsTypes | matchKnotsType | ) |
Sets a constraint to match knots at the defining points for a through point spline
Created in NX8.0.0.
License requirements : features_modeling ("FEATURES MODELING") OR cam_base ("CAM BASE")
matchKnotsType | matchknotstype |
void NXOpen::Features::StudioSplineBuilderEx::SetMovementMethod | ( | NXOpen::Features::StudioSplineBuilderEx::MovementMethodType | movementMethod | ) |
Sets the movement method
Created in NX8.0.0.
License requirements : features_modeling ("FEATURES MODELING") OR cam_base ("CAM BASE")
movementMethod | movementmethod |
void NXOpen::Features::StudioSplineBuilderEx::SetMovementPlane | ( | NXOpen::Plane * | movementPlane | ) |
Sets the movement plane
Created in NX8.0.0.
License requirements : features_modeling ("FEATURES MODELING") OR cam_base ("CAM BASE")
movementPlane | movementplane |
void NXOpen::Features::StudioSplineBuilderEx::SetMovementVector | ( | NXOpen::Direction * | movementVector | ) |
Sets the movement vector
Created in NX8.0.0.
License requirements : features_modeling ("FEATURES MODELING") OR cam_base ("CAM BASE")
movementVector | movementvector |
void NXOpen::Features::StudioSplineBuilderEx::SetParameters | ( | const std::vector< double > & | parameters | ) |
Sets the optional parameters at defining points for a through point spline
Created in NX8.0.0.
License requirements : features_modeling ("FEATURES MODELING") OR cam_base ("CAM BASE")
parameters | The parameters |
void NXOpen::Features::StudioSplineBuilderEx::SetPeriodic | ( | bool | periodicity | ) |
Sets the periodicity
Created in NX8.0.0.
License requirements : features_modeling ("FEATURES MODELING") OR cam_base ("CAM BASE")
periodicity | periodicity |
void NXOpen::Features::StudioSplineBuilderEx::SetSingleSegment | ( | bool | isSingleSegment | ) |
Sets a flag indicating if single segment by pole spline is to be created
Created in NX8.0.0.
License requirements : features_modeling ("FEATURES MODELING") OR cam_base ("CAM BASE")
isSingleSegment | issinglesegment |
void NXOpen::Features::StudioSplineBuilderEx::SetType | ( | NXOpen::Features::StudioSplineBuilderEx::Types | type | ) |
Sets the spline method
Created in NX8.0.0.
License requirements : features_modeling ("FEATURES MODELING") OR cam_base ("CAM BASE")
type | type |
void NXOpen::Features::StudioSplineBuilderEx::SetWCSOption | ( | NXOpen::Features::StudioSplineBuilderEx::WCSOptionType | wcsOption | ) |
Sets the WCS option
Created in NX8.0.0.
License requirements : features_modeling ("FEATURES MODELING") OR cam_base ("CAM BASE")
wcsOption | wcsoption |
NXOpen::Features::StudioSplineBuilderEx::Types NXOpen::Features::StudioSplineBuilderEx::Type | ( | ) |
Returns the spline method
Created in NX8.0.0.
License requirements : None
void NXOpen::Features::StudioSplineBuilderEx::UpdateOnConstraintPlane | ( | ) |
Updates spline based on constraint plane
Created in NX8.0.0.
License requirements : features_modeling ("FEATURES MODELING") OR cam_base ("CAM BASE")
NXOpen::Features::StudioSplineBuilderEx::WCSOptionType NXOpen::Features::StudioSplineBuilderEx::WCSOption | ( | ) |
Returns the WCS option
Created in NX8.0.0.
License requirements : None